<template>
  <div class="flex flex-row h-screen">
    <div class="flex flex-col justify-end w-2/3 mb-10">
      <div class="flex flex-col overflow-y-auto overflow-anchor">
        <Message
          v-for="message in messages"
          :key="message.createdAt"
          :message="message.content"
          :role="message.user.role"
          :owned="message.user.email === email"
          :photo="message.user.imgUrl"
        />
      </div>
      <input
        class="scroll-to-me mx-4 my-2 rounded-full py-2 px-4 bg-gray-600 text-white"
        placeholder="Send a message ..."
        type="text"
        v-model="input"
        v-on:keyup.enter="submit"
      />
    </div>
    <div class="w-1/3"><SidePanel /></div>
  </div>
</template>

<script>
import { defineComponent, ref, toRefs, reactive } from "vue";
import Message from "@/components/Message";
import SidePanel from "@/components/SidePanel";
import { store } from "@/store";
import { $auth0 } from "@/auth0";

export default defineComponent({
  name: "Chat",
  components: {
    Message,
    SidePanel,
  },
  setup() {
    const limit = 25;
    const offset = 0;
    store.actions.getMessagesPaginated(limit, offset);
    setInterval(() => store.actions.getMessagesPaginated(limit, offset), 2000);
    const messages = toRefs(store.state).messages;
    const email = ref($auth0.state.user.email);
    const input = ref("");

    const submit = () => {
      if (!input.value || input.value === "") {
        return;
      }
      store.actions
        .createMessage(input.value, store.state.user.id)
        .then(() => (input.value = ""));
    };
    return { submit, messages, email, input };
  },
});
</script>
<style>
.overflow-anchor {
  overflow-anchor: auto;
}
</style>
